# namespace
package Config::General::Substitute;

use Config::General 1.28;

use Carp;
use vars qw(@ISA);

# inherit new() and so on from Config::General
@ISA = qw(Config::General);

use strict;

$Config::General::Substitute::VERSION = "1.0";



=head1

# quasi code:

sub vars {
  my($this, $config, $stack) = @_;

  my @varstack;

  foreach keys %config {
    if value eq scalar {
      put on @varstack
      if contains [${()}] or so {
         foreach @varstack {
            replace it
         }
      }
    }
    else {
      # recursive call to vars(), which gets the currently "known"
      # vars passed as 2nd argument(arrayref), so varibales are
      # only visible within it's scope.
      &vars($config, [@{$stack}, @varstack])
    }
  }
  return %config;
}

=cut
